include \masm32\include\masm32rt.inc
include \masm32\include\ws2_32.inc
includelib \masm32\lib\ws2_32.lib

fixpoint64 struct
	int_part	DWORD ?
	fraction	DWORD ?
fixpoint64 ends
fixpoint32 struct
	int_part	WORD ?
	fraction	WORD ?
fixpoint32 ends

NTP_DATA struct
	LI_VN_Mode			BYTE	?
	Stratum				BYTE	?
	Poll				BYTE	?
	Precision			BYTE	?
	RootDelay			fixpoint32	<>
	RootDispersion		fixpoint32	<>
	ReferenceIdentifier	DWORD	?
	ReferenceTimestamp	fixpoint64	<>
	OriginateTimestamp	fixpoint64	<>
	ReceiveTimestamp	fixpoint64	<>
	TransmitTimestamp	fixpoint64	<>
NTP_DATA ends


.data?

ipname dd ?
txtbuff db 4096 DUP (?)


.code

main proc
LOCAL wsadata:WSADATA
LOCAL Socket:SOCKET
LOCAL ip:sockaddr_in
LOCAL sz[SIZEOF NTP_DATA]:CHAR
LOCAL ipLen:DWORD
LOCAL ntpRequest:NTP_DATA
LOCAL ntp:NTP_DATA
LOCAL qw:QWORD
LOCAL syst:SYSTEMTIME
LOCAL base:SYSTEMTIME


	invoke WSAStartup,2,ADDR wsadata
	
	mov Socket,rv(socket,AF_INET,SOCK_DGRAM,0)
	.if Socket != INVALID_SOCKET
		.if rv(gethostbyname,"time1.nimt.or.th")
			mov esi,eax
			.if [esi].hostent.h_list
				mov eax,[esi].hostent.h_list
				mov eax,[eax]
				.if eax
					mov esi,[eax]
					
					invoke inet_ntoa,esi
                                 mov ipname, eax
					Invoke lstrcat, eax, CTXT(":123")
					invoke RtlZeroMemory,ADDR ip,SIZEOF ip
					mov ip.sin_family,AF_INET
					mov ip.sin_port,123 SHL 8
					mov ip.sin_addr.S_un.S_addr,esi
					
					invoke connect,Socket,ADDR ip,SIZEOF ip
					
					invoke RtlZeroMemory,ADDR ntpRequest,SIZEOF ntpRequest
					mov ntpRequest.LI_VN_Mode,(4 SHl 3) OR 3  ; version 4, mode = 3 = client
					
					.if rv(sendto,Socket,ADDR ntpRequest,SIZEOF ntpRequest,0,ADDR ip,SIZEOF ip) != SOCKET_ERROR
						mov ipLen,SIZEOF ip
						.if rv(recvfrom,Socket,ADDR ntp,SIZEOF ntp,0,ADDR ip,ADDR ipLen) != SOCKET_ERROR
							lea esi,ntp
							
							mov eax,[esi].NTP_DATA.TransmitTimestamp.int_part
							bswap eax
							mov [esi].NTP_DATA.TransmitTimestamp.int_part,eax
							mov eax,[esi].NTP_DATA.TransmitTimestamp.fraction
							bswap eax
							mov [esi].NTP_DATA.TransmitTimestamp.fraction,eax
								
							finit
							m2m DWORD ptr qw[0],[esi].NTP_DATA.TransmitTimestamp.fraction
							m2m DWORD ptr qw[4],0
							fild qw
							mov DWORD ptr qw[0],0
							mov DWORD ptr qw[4],1
							fild qw
							fdivp st(1),st
							m2m DWORD ptr qw[0],[esi].NTP_DATA.TransmitTimestamp.int_part
							m2m DWORD ptr qw[4],0
							fild qw
							faddp st(1),st
								
							mov base.wYear,1900
							mov base.wMonth,1
							mov base.wDay,1
							mov base.wHour,0
							mov base.wMinute,0
							mov base.wSecond,0
							mov base.wMilliseconds,0
								
							invoke SystemTimeToFileTime,ADDR base,ADDR qw
							
							fmul FP8(1.0E7)
							fild qw
							faddp st(1),st
							fistp qw
								
							invoke FileTimeToLocalFileTime,ADDR qw,ADDR qw
							invoke FileTimeToSystemTime,ADDR qw,ADDR syst
								
Invoke wsprintf, OFFSET txtbuff, CTXT("%02lu/%02lu/%04lu  %02lu:%02lu:%02lu.%lu"), syst.wDay,syst.wMonth,syst.wYear,syst.wHour,syst.wMinute,syst.wSecond,syst.wMilliseconds
Invoke MessageBox,0,OFFSET txtbuff,ipname,0
                                        .else
							Invoke MessageBox,0,CTXT("recvfrom error"),0,0
						.endif
                                    .else
						Invoke MessageBox,0,CTXT("sendto error"),0,0
                                    .endif
				.else
					Invoke MessageBox,0,CTXT("error"),0,0
				.endif
			.else
				Invoke MessageBox,0,CTXT("error"),0,0
			.endif
		.else
			Invoke MessageBox,0,CTXT("can't resolve server"),0,0
		.endif
		invoke closesocket,Socket
	.else
		Invoke MessageBox,0,CTXT("can't create socket"),0,0
	.endif

	invoke WSACleanup

    ret
main endp

start:

call main
Invoke ExitProcess, 0

end start
